import waba.ui.*;
import waba.fx.*;

/**
  Button UI class
  */
public class HGButton extends Control {
  public boolean inPress;
  //private Image[] img;
  private Image img;
  private Font font;
  private String text;
  public boolean tglf = false;

  public HGButton(String text, Font font,
   int x, int y, int width, int height) {
    setRect(x, y, width, height);
    this.font = font;
    /*img = new Image[2];
    for ( int i=0 ; i<2 ; i++ ) {
      img[i] = new Image(width, height);
    }*/
    //img = new Image(width, height);
    this.text = text;
    //setText(text);
  }

  public HGButton(String text, Font font,
   int x, int y, int width, int height, boolean tglf) {
    this(text, font, x, y, width, height);
    this.tglf = tglf;
  }

  public void setText(String text) {
    this.text = text;
    img = null;
    repaint();
  }

  public void setTextImg(String text) {
    img = new Image(width, height);

    int textX, textY;
  	FontMetrics fm = getFontMetrics(font);
	  textX = (width - fm.getTextWidth(text)) / 2;
	  textY = (height - fm.getHeight()) / 2;
    /*nfor ( int i=0 ; i<2 ; i++ ) {
      Graphics g = new Graphics(img[i]);
      g.setColor(255, 255, 255);
      g.fillRect(0, 0, width, height);
      if ( i==1 ) {
        g.setColor(0, 0, 0);
        g.fillRect(1, 1, width-2, height-2);
        g.setColor(255, 255, 255);
      } else {
        g.setColor(0, 0, 0);
      }
      g.drawLine(1, 0, width-2, 0);
      g.drawLine(0, 1, 0, height-2);
      g.drawLine(1, height-1, width-2, height-1);
      g.drawLine(width-1, 1, width-1, height-2);
      g.setFont(font);
      g.drawText(text, textX, textY);
    }*/
    Graphics g = new Graphics(img);
    g.setColor(255, 255, 255);
    g.fillRect(0, 0, width, height);
    g.setColor(0, 0, 0);
    g.drawLine(1, 0, width-2, 0);
    g.drawLine(0, 1, 0, height-2);
    g.drawLine(1, height-1, width-2, height-1);
    g.drawLine(width-1, 1, width-1, height-2);
    g.setFont(font);
    g.drawText(text, textX, textY);
    if ( inPress ) check();
  }

  private void check() {
    if ( img == null ) return;
    Graphics g = new Graphics(img);
    g.setColor(0, 0, 0);
    g.drawLine(2, 2, width-3, 2);
    g.drawLine(width-3, 2, width-3, height-3);
    g.drawLine(width-3, height-3, 2, height-3);
    g.drawLine(2, height-3, 2, 2);
  }

  private void uncheck() {
    if ( img == null ) return;
    Graphics g = new Graphics(img);
    g.setColor(255, 255, 255);
    g.drawLine(2, 2, width-3, 2);
    g.drawLine(width-3, 2, width-3, height-3);
    g.drawLine(width-3, height-3, 2, height-3);
    g.drawLine(2, height-3, 2, 2);
  }

  public void setCheck(boolean f) {
    if ( f != inPress ) {
      inPress = f;
      if ( inPress ) check();
      else uncheck();
    }
    repaint();
  }

  public void onEvent(Event e) {
    if ( e.type == PenEvent.PEN_DOWN ) {
      if ( tglf ) {
        inPress = !inPress;
        if ( inPress ) {
          parent.postEvent(new HGButtonEvent(HGButtonEvent.CHECKED, this));
        } else {
          parent.postEvent(new HGButtonEvent(HGButtonEvent.UNCHECKED, this));
        }
      } else {
        inPress = true;
      }
      if ( inPress ) check();
      else uncheck();
      repaint();
    } else if ( e.type == PenEvent.PEN_UP ) {
      if ( !tglf ) {
        if ( inPress ) {
          inPress = false;
          uncheck();
          repaint();
          parent.postEvent(new HGButtonEvent(HGButtonEvent.PRESSED, this));
        }
      }
    }
  }

  public void onPaint(Graphics grp) {
    /*int i=0;
    if ( inPress ) i=1;
    grp.drawImage(img[i], x, y);*/
    if ( img == null ) {
      setTextImg(text);
      if ( inPress ) check();
      else uncheck();
    }
    grp.drawImage(img, 0, 0);
  }
}

