import waba.sys.Vm;

/**
  Game event management class
  */
public class HGEvent {
  /** condition
    0: spc  0 - onKeyPress  1 - on        2 - off
    1: prm        spc             objNmb        objNmb
    2: prm
            10-19 - onTimer
                      tmrMin
                      tmrMax
            20-29 - onRandom
                      numerator
                      denominator */
  public byte[] cnd;
  public int cndCnt;
  private int nextTime;
  /** action
    0: spc  1 - on        2 - off     3- move    4 - miss  5 - score
    1: prm      objNmb        objNmb     objNmb                score
    2: time */
  public byte[] act;
  public int actCnt;
  private int[] onoffTrgObjNmb;
  private boolean[] onoffTrg;
  private boolean onoffCnd;

  public HGEvent() {
    cnd = null;
    cnd = new byte[99*3];
    cndCnt = 0;
    act = null;
    act = new byte[99*3];
    actCnt = 0;
  }

  public HGEvent(HGEvent evt) {
    cnd = null;
    cnd = new byte[99*3];
    cndCnt = evt.cnd.length;
    Vm.copyArray(evt.cnd, 0, cnd, 0, cndCnt);
    act = null;
    act = new byte[99*3];
    actCnt = evt.act.length;
    Vm.copyArray(evt.act, 0, act, 0, actCnt);
  }

  public boolean addCnd(int spc, int prm1) {
    return addCnd((byte)spc, (byte)prm1, (byte)0);
  }

  public boolean addCnd(byte spc, byte prm1) {
    return addCnd(spc, prm1, (byte)0);
  }

  public boolean addCnd(int spc, int prm1, int prm2) {
    return addCnd((byte)spc, (byte)prm1, (byte)prm2);
  }

  public boolean addCnd(byte spc, byte prm1, byte prm2) {
    if ( cndCnt >= 99*3 ) return false;
    for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
      if ( cnd[i] == spc && cnd[i+1] == prm1 ) return false;
    }
    cnd[cndCnt] = spc; cnd[cndCnt+1] = prm1; cnd[cndCnt+2] = prm2;
    cndCnt += 3;
    return true;
  }

  public boolean delCnd(int spc) {
    return delCnd((byte)spc);
  }

  public boolean delCnd(byte spc) {
    if ( spc == 10 ) {
      for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
        if ( cnd[i]>=10 && cnd[i]<20 ) {
          for ( int j=i ; j<cndCnt-3 ; j++ ) {
            cnd[j] = cnd[j+3];
          }
          cndCnt -= 3;
          return true;
        }
      }
    } else if ( spc == 20 ) {
      for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
        if ( cnd[i]>=20 && cnd[i]<30 ) {
          for ( int j=i ; j<cndCnt-3 ; j++ ) {
            cnd[j] = cnd[j+3];
          }
          cndCnt -= 3;
          return true;
        }
      }
    } else {
      for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
        if ( cnd[i] == spc ) {
          for ( int j=i ; j<cndCnt-3 ; j++ ) {
            cnd[j] = cnd[j+3];
          }
          cndCnt -= 3;
          return true;
        }
      }
    }
    return false;
  }

  public boolean delCnd(int spc, int prm1) {
    return delCnd((byte)spc, (byte)prm1);
  }

  public boolean delCnd(byte spc, byte prm1) {
    for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
      if ( cnd[i] == spc && cnd[i+1] == prm1 ) {
        for ( int j=i ; j<cndCnt-3 ; j++ ) {
          cnd[j] = cnd[j+3];
        }
        cndCnt -= 3;
        return true;
      }
    }
    return false;
  }

  public void delCnds(int objNmb) {
    delCnds((byte)objNmb);
  }

  public void delCnds(byte objNmb) {
    for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
      if ( cnd[i]>=1 && cnd[i]<=2 && cnd[i+1]==objNmb ) {
        for ( int j=i ; j<cndCnt-3 ; j++ ) {
          cnd[j] = cnd[j+3];
        }
        cndCnt -= 3;
      }
    }
  }

  public boolean addAct(int idx, int spc, int prm, int tm, boolean dragf) {
    int idx3 = idx*3;
    if ( dragf && idx3 >= 3 &&
     act[idx3-3] <= 3 && act[idx3-3] == spc && act[idx3-2] == prm ) return false;
    else return addAct(idx, (byte)spc, (byte)prm, (byte)tm);
  }

  public boolean addAct(int idx, int spc, int tm) {
    return addAct(idx, (byte)spc, (byte)-1, (byte)tm);
  }

  public boolean addAct(int idx, byte spc, byte tm) {
    return addAct(idx, spc, (byte)-1, tm);
  }

  public boolean addAct(int idx, int spc, int prm, int tm) {
    return addAct(idx, (byte)spc, (byte)prm, (byte)tm);
  }

  public boolean addAct(int idx, byte spc, byte prm, byte tm) {
    int idx3 = idx*3;
    if ( actCnt >= 98*3 ) actCnt = 98*3;
    for ( int i=actCnt-1 ; i>=idx3 ; i-- ) {
      act[i+3] = act[i];
    }
    act[idx3] = spc; act[idx3+1] = prm; act[idx3+2] = tm;
    actCnt += 3;
    return true;
  }

  public void delAct(int idx) {
    if ( actCnt <= idx ) return;
    int idx3 = idx*3;
    actCnt -= 3;
    for ( int i=idx3 ; i<actCnt ; i++ ) {
      act[i] = act[i+3];
    }
    for ( int i=actCnt ; i<actCnt+3 ; i++ ) {
      act[i] = 0;
    }
  }

  public void delActs(int objNmb) {
    delActs((byte)objNmb);
  }

  public void delActs(byte objNmb) {
    for ( int i=actCnt-3 ; i>=0 ; i-=3 ) {
      if ( ( act[i] == 1 || act[i] == 2 || act[i] == 3 ) && act[i+1] == objNmb ) {
        delAct((int)(i/3));
      }
    }
  }

  public byte containsHObj(int idx) {
    return containsHObj((byte)idx);
  }

  public byte containsHObj(byte idx) {
    for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
      if ( (cnd[i]==1 || cnd[i]==2) && cnd[i+1] == idx ) {
        return cnd[i];
      }
    }
    return -1;
  }

  public int containsSpc(int spc) {
    return containsSpc((byte)spc);
  }

  public int containsSpc(byte spc) {
    if ( spc == 10 ) {
      for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
        if ( cnd[i]>=10 && cnd[i]<20 ) {
          return i;
        }
      }
    } else if ( spc == 20 ) {
      for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
        if ( cnd[i]>=20 && cnd[i]<30 ) {
          return i;
        }
      }
    } else {
      for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
        if ( cnd[i] == spc ) {
          return i;
        }
      }
    }
    return -1;
  }

  public void cmprsData() {
    byte[] tcnd = cnd;
    cnd = new byte[cndCnt];
    Vm.copyArray(tcnd, 0, cnd, 0, cndCnt);
    tcnd = null;
    byte[] tact = act;
    act = new byte[actCnt];
    Vm.copyArray(tact, 0, act, 0, actCnt);
    tact = null;
  }

  public void validData() {
    onoffCnd = true;
    byte[] otrgnmbtmp = new byte[(int)(cnd.length/3)];
    int trgIdx = 0;
    for ( int i=cndCnt-3 ; i>=0 ; i-=3 ) {
      if ( cnd[i]>=10 && cnd[i]<20 ) {
        int tw = cnd[i+2]-cnd[i+1];
        if ( tw > 0 ) nextTime = cnd[i+1] + abs(Rnd.nextInt()%tw);
        else nextTime = cnd[i+1];
      } else {
        switch ( cnd[i] ) {
          case 1:
            onoffCnd = false;
            otrgnmbtmp[trgIdx] = cnd[i+1];
            trgIdx++;
            break;
          case 2:
            onoffCnd = false;
            otrgnmbtmp[trgIdx] = cnd[i+1];
            trgIdx++;
            break;
        }
      }
    }
    if ( !onoffCnd ) {
      onoffTrgObjNmb = new int[trgIdx];
      onoffTrg = new boolean[trgIdx];
      for ( int i=onoffTrgObjNmb.length-1 ; i>=0 ; i-- ) {
        onoffTrgObjNmb[i] = otrgnmbtmp[i];
        onoffTrg[i] = false;
      }
    }
  }

  public HGAction getHGAction() {
    return new HGAction(act);
  }

  public void onByHnyObj(int objNmb) {
    onoffCnd = true;
    for ( int i = onoffTrgObjNmb.length-1 ; i >= 0 ; i-- ) {
      if ( onoffTrgObjNmb[i] == objNmb ) {
        onoffTrg[i] = true;
      }
      onoffCnd &= onoffTrg[i];
    }
  }

  public void offByHnyObj(int objNmb) {
    for ( int i = onoffTrgObjNmb.length-1 ; i >= 0 ; i-- ) {
      if ( onoffTrgObjNmb[i] == objNmb ) {
        onoffTrg[i] = false;
        break;
      }
    }
    onoffCnd = false;
  }

  public boolean checkOcr(int rnk) {
    if ( cndCnt <= 0 ) return false;
    if ( !onoffCnd ) return false;
    for ( int i=cndCnt-3 ; i >= 0 ; i -= 3 ) {
      int cd = cnd[i];
      if ( cd>=10 && cd<20 ) {
        nextTime--;
        if ( nextTime <= 0 ) {
          int tw = cnd[i+2]-cnd[i+1];
          if ( tw > 0 ) nextTime = cnd[i+1] + abs(Rnd.nextInt()%tw);
          else nextTime = cnd[i+1];
          nextTime *= ((cd-12)*((float)(60-rnk)/150) + 1);
        } else {
          return false;
        }
      } else if ( cd>=20 && cd<30 ) {
        if ( abs(Rnd.nextInt()%(cnd[i+2]*150)) >= cnd[i+1]*((cd-22)*(60-rnk)+150) ) return false;
      } else if ( cd==0 ) {
        return false;
      }
    }
    return true;
  }

  public final boolean checkOcr(boolean[] keys, int rnk) {
    boolean ocrf = false;
    if ( cndCnt <= 0 ) return false;
    if ( !onoffCnd ) return false;
    for ( int i=cndCnt-3 ; i >= 0 ; i -= 3 ) {
      int cd = cnd[i];
      if ( cd>=10 && cd<20 ) {
        if ( nextTime > 1 ) return false;
      } else if ( cd>=20 && cd<30 ) {
        if ( abs(Rnd.nextInt()%cnd[i+2]*150) >= cnd[i+1]*((cd-22)*(60-rnk)+150) ) return false;
      } else if ( cd==0 ) {
        if ( !keys[cnd[i+1]] ) return false;
        else ocrf = true;
      }
    }
    return ocrf;
  }

  private int abs(int n) {
    if ( n >= 0 ) return n;
    else return -n;
  }

  public byte[] writeObject() {
    byte[] bst = new byte[4+cndCnt+actCnt];
    bst[2] = (byte)(cndCnt/3);
    int c = 3;
    Vm.copyArray(cnd, 0, bst, c, cndCnt);
    c += cndCnt;
    bst[c] = (byte)(actCnt/3); c++;
    Vm.copyArray(act, 0, bst, c, actCnt);
    return bst;
  }

  public void readObject(byte[] bst) {
    cndCnt = (int)bst[2]*3;
    int c = 3;
    Vm.copyArray(bst, c, cnd, 0, cndCnt);
    c += cndCnt;
    actCnt = (int)bst[c]*3; c++;
    Vm.copyArray(bst, c, act, 0, actCnt);
    cmprsData();
  }
}
