import waba.ui.*;
import waba.fx.*;

/**
  Button UI class (memory saving)
  */
public class HGMsBtn extends Control {
  private Font font;
  private ISurface surf;
  private String text;

  public HGMsBtn(String text, Font font, int x, int y, int width, int height) {
    setRect(x, y, width, height);
    this.font = font;
    setText(text);
  }

  public void setText(String text) {
    this.text = text;
  }

  public void onEvent(Event e) {
    if ( e.type == PenEvent.PEN_DOWN ) {
      postEvent(new HGButtonEvent(HGButtonEvent.PRESSED, this));
    }
  }

  public void onPaint(Graphics grp) {
    int textX, textY;
  	FontMetrics fm = getFontMetrics(font);
	  textX = (width - fm.getTextWidth(text)) / 2;
	  textY = (height - fm.getHeight()) / 2;
    grp.setColor(255, 255, 255);
    grp.fillRect(0, 0, width, height);
    grp.setColor(0, 0, 0);
    grp.drawLine(1, 0, width-2, 0);
    grp.drawLine(0, 1, 0, height-2);
    grp.drawLine(1, height-1, width-2, height-1);
    grp.drawLine(width-1, 1, width-1, height-2);
    grp.setFont(font);
    grp.drawText(text, textX, textY);
  }
}
