import waba.ui.*;
import waba.fx.*;
import waba.sys.Convert;

/**
  Spin number UI class
  */
public class HGSpinNmb extends Container {
  private HGMsBtn uup, udwn, lup, ldwn;
  public HGButton nmb;
  public int number;
  public int max, min;

  public HGSpinNmb(int min, int max, int x, int y) {
    this(min, min, max, x, y);
  }

  public HGSpinNmb(int n, int min, int max, int x, int y) {
    setRect(x, y, 30, 15);
    String ns = Convert.toString(n);
    Font fn = new Font("Helvetica", Font.BOLD, 10);
    nmb = new HGButton(ns, fn, 7, 0, 16, 15);
    uup = new HGMsBtn("", fn, 0, 0, 7, 7);
    udwn = new HGMsBtn("", fn, 0, 8, 7, 7);
    lup = new HGMsBtn("", fn, 23, 0, 7, 7);
    ldwn = new HGMsBtn("", fn, 23, 8, 7, 7);
    add(nmb);
    add(uup); add(udwn); add(lup); add(ldwn);
    number = n;
    this.min = min; this.max = max;
  }

  public void setNumber(int n) {
    setNumberWOEvent(n);
    if ( parent != null ) {
      parent.postEvent(new HGSpinNmbEvent(HGSpinNmbEvent.CHANGED, this));
    }
  }

  public void setNumberWOEvent(int n) {
    number = n;
    nmb.setText(Convert.toString(number));
  }

  public void setNumberRgn(int n) {
    setNumberRgnWOEvent(n);
    if ( parent != null ) {
      parent.postEvent(new HGSpinNmbEvent(HGSpinNmbEvent.CHANGED, this));
    }
  }

  public void setNumberRgnWOEvent(int n) {
    number = n;
    if ( number > max ) number = max;
    if ( number < min ) number = min;
    nmb.setText(Convert.toString(number));
  }

  public void onEvent(Event e) {
    boolean isChg = false;
    if ( e.type == ControlEvent.PRESSED ) {
      if ( e.target == uup ) {
        number += 10;
        if ( number > max ) {
          number -= 10;
          int n = number;
          number = (number%10)+(min/10)*10;
          if ( number < min ) number = n;
        }
        isChg = true;
      } else if ( e.target == udwn ) {
        number -= 10;
        if ( number < min ) {
          number += 10;
          int n = number;
          number = (number%10)+(max/10)*10;
          if ( number > max ) number = n;
        }
        isChg = true;
      } else if ( e.target == lup ){
        number++;
        if ( number > max ) number = min;
        isChg = true;
      } else if ( e.target == ldwn ) {
        number--;
        if ( number < min ) number = max;
        isChg = true;
      }
      if ( isChg ) {
        nmb.setText(Convert.toString(number));
        nmb.repaint();
        parent.postEvent(new HGSpinNmbEvent(HGSpinNmbEvent.CHANGED, this));
      }
    }
  }

  public void onPaint(Graphics grp) {}
}
