import waba.fx.*;
import waba.io.*;
import waba.sys.*;

/**
  Blink object on LCD(screen canvas)
  */
public class HnyObj {
  static public void setGrpMode(Graphics g) {
  }

  static public void resetGrpMode(Graphics g) {
  }

  public boolean onoff;
  public int x, y;
  public int width, height;
  //public Image img;
  public int nmb, ctg;
  public byte[] pdx, pdy;
  public int pdIdx;
  public HGEvent[] onTrg, offTrg;
  public int onTrgCnt, offTrgCnt;

  private Graphics grp;
  private Image oimg;

  public HnyObj(Graphics grp, Image oimg) {
    this.grp = grp;
    this.oimg = oimg;
  }

  //public HnyObj(Image img, Graphics grp, int x, int y, byte[] pdx, byte[] pdy, int pdIdx) {
  public HnyObj(Graphics grp, Image oimg, byte[] pdx, byte[] pdy, int pdIdx) {
    //this(img, grp, x, y, -1, -1, pdx, pdy, pdIdx);
    this(grp,  oimg, -1, -1, pdx, pdy, pdIdx);
  }

  //public HnyObj(Image img, Graphics grp, int x, int y, int nbm, int ctg, byte[] pdx, byte[] pdy, int pdIdx) {
  public HnyObj(Graphics grp, Image oimg, int nbm, int ctg, byte[] pdx, byte[] pdy, int pdIdx) {
    //this.img = img;
    //this.x = x; this.y = y;
    //Size sz = img.getSize();
    //width = sz.getWidth(); height = sz.getHeight();
    this.grp = grp;
    this.oimg = oimg;
    this.nmb = nbm;
    this.ctg = ctg;
    onoff = false;
    onTrg = offTrg = null;
    this.pdIdx = pdIdx;
    this.pdx = new byte[pdIdx];
    this.pdy = new byte[pdIdx];
    //for ( int i = pdIdx-1 ; i > 0 ; i-- ) {
    //  this.pdx[i] = pdx[i]; this.pdy[i] = pdy[i];
    //}
    int xMax = -1, yMax = -1;
    x = y = 10000;
    for ( int i = pdIdx-1 ; i > 0 ; i-- ) {
      this.pdx[i] = pdx[i]; this.pdy[i] = pdy[i];
      if ( pdx[i] != -1 ) {
        int dx = (int)pdx[i]&255, dy = (int)pdy[i]&255;
        if ( dx < x ) x = dx;
        if ( dy < y ) y = dy;
        if ( dx > xMax ) xMax = dx;
        if ( dy > yMax ) yMax = dy;
      }
    }
    width = xMax-x+1; height = yMax-y+1;
  }

  public void addOnTrg(HGEvent evt) {
    onTrg[onTrgCnt] = evt;
    onTrgCnt++;
  }

  public void addOffTrg(HGEvent evt) {
    offTrg[offTrgCnt] = evt;
    offTrgCnt++;
  }

  public void draw() {
    //grp.drawImage(img, hobj.x, hobj.y);
    grp.copyRect(oimg, x, y, width, height, x, y);
  }

  public void clear() {
    //grp.setClip(x, y, width, height);
    //grp.clearClip();
    grp.fillRect(x, y, width, height);
  }

  public void draw(Graphics grp) {
    int px = pdx[pdIdx-1]&255, py = pdy[pdIdx-1]&255, npx, npy;
    for ( int i = pdIdx-2 ; i > 0 ; i-- ) {
      if ( pdx[i] != -1 ) {
        npx = pdx[i]&255; npy = pdy[i]&255;
        grp.drawLine(px, py, npx, npy);
      } else {
        i--;
        npx = pdx[i]&255; npy = pdy[i]&255;
      }
      px = npx; py = npy;
    }
  }

  public void drawImage(Graphics grp) {
    int px = (pdx[pdIdx-1]&255)-x, py = (pdy[pdIdx-1]&255)-y, npx, npy;
    for ( int i = pdIdx-2 ; i > 0 ; i-- ) {
      if ( pdx[i] != -1 ) {
        npx = (pdx[i]&255)-x; npy = (pdy[i]&255)-y;
        grp.drawLine(px, py, npx, npy);
      } else {
        i--;
        npx = (pdx[i]&255)-x; npy = (pdy[i]&255)-y;
      }
      px = npx; py = npy;
    }
  }

  /*public void writePD(int nmb) {
    char[] nc = {'a', 'a', 'n', 'T', '.', 'T', 'M', '0', '0'};
    nc[7] = (char)('0' + (int)(nmb/10));
    nc[8] = (char)('0' + (int)(nmb%10));
    Catalog ct = new Catalog(new String(nc), Catalog.WRITE_ONLY);
    if ( ct.isOpen() ) ct.delete();
    ct = new Catalog(new String(nc), Catalog.CREATE);
    if ( !ct.isOpen() ) return;

    ct.addRecord(pdIdx*2);
    ct.writeBytes(pdx, 0, pdIdx);
    ct.writeBytes(pdy, 0, pdIdx);
    ct.close();
    pdx = null; pdy = null;
  }

  public void readPD(int nmb) {
    char[] nc = {'a', 'a', 'n', 'T', '.', 'T', 'M', '0', '0'};
    nc[7] = (char)('0' + (int)(nmb/10));
    nc[8] = (char)('0' + (int)(nmb%10));
    Catalog ct = new Catalog(new String(nc), Catalog.READ_ONLY);
    if ( !ct.isOpen() ) return;
    ct.setRecordPos(0);
    pdx = new byte[pdIdx];
    pdy = new byte[pdIdx];
    ct.readBytes(pdx, 0, pdIdx);
    ct.readBytes(pdy, 0, pdIdx);
    ct.close();
  }*/

  public byte[] writeObject() {
    byte[] bst = new byte[pdIdx*2 + 14];
    int c = 2;
    Vm.copyArray(pdx, 0, bst, c, pdIdx);
    c += pdIdx;
    Vm.copyArray(pdy, 0, bst, c, pdIdx);
    c += pdIdx;
    bst[c] = (byte)(x&127); bst[c+1] = (byte)(x/128); c += 2;
    bst[c] = (byte)(y&127); bst[c+1] = (byte)(y/128); c += 2;
    bst[c] = (byte)(width&127); bst[c+1] = (byte)(width/128); c += 2;
    bst[c] = (byte)(height&127); bst[c+1] = (byte)(height/128); c += 2;
    bst[c] = (byte)(nmb&127); bst[c+1] = (byte)(nmb/128); c += 2;
    bst[c] = (byte)(ctg&127); bst[c+1] = (byte)(ctg/128); c += 2;
    return bst;
  }

  public void readObject(byte[] bst) {
    int c = 2;
    pdIdx = (bst.length-14)/2;
    pdx = new byte[pdIdx]; pdy = new byte[pdIdx];
    Vm.copyArray(bst, c, pdx, 0, pdIdx);
    c += pdIdx;
    Vm.copyArray(bst, c, pdy, 0, pdIdx);
    c += pdIdx;
    x = bst[c] + bst[c+1]*128; c += 2;
    y = bst[c] + bst[c+1]*128; c += 2;
    width = bst[c] + bst[c+1]*128; c += 2;
    height = bst[c] + bst[c+1]*128; c += 2;
    nmb = bst[c] + bst[c+1]*128; c += 2;
    ctg = bst[c] + bst[c+1]*128; c += 2;
    /*img = new Image(width, height);
    Graphics g = new Graphics(img);
    g.setDrawOp(Graphics.DRAW_OVER);
    g.setColor(255, 255, 255);
    g.fillRect(0, 0, width, height);
    g.setColor(0, 0, 0);
    int px = pdx[pdIdx-1]&255, py = pdy[pdIdx-1]&255, npx, npy;
    px -= x; py -= y;
    for ( int i = pdIdx-2 ; i > 0 ; i-- ) {
      if ( pdx[i] != -1 ) {
        npx = pdx[i]&255; npy = pdy[i]&255;
        npx -= x; npy -= y;
        g.drawLine(px, py, npx, npy);
      } else {
        i--;
        npx = pdx[i]&255; npy = pdy[i]&255;
        npx -= x; npy -= y;
      }
      px = npx; py = npy;
    }*/
  }
}

