import waba.ui.*;
import waba.fx.*;

/**
  Input event data UI
  */
public class InputEvt extends RmblContainer implements ICanvasParent {
  private IHenyaG henyaG;
  private HGButton eeTgl, allBtn, delBtn;
  private HGToggleBox ctg;
  private HGToggleBox onfBox, evtBox;
  private HGCanvas cvs;
  private HGSpinNmb evtNmb, prm1Nmb, prm2Nmb;
  private HGToggleBox rnkBox;
  private HGToggleBox keyBox;
  private HGButton clrBtn;
  private HGButton doneBtn;
  private HnyObj[] hnyObj;
  private HGEvent[] hgEvt;
  private HGEvent edEvt;
  private boolean inPress;
  private int prvEvtIdx;
  private HGButton actTgr;
  private HGToggleBox actBox;
  private HGSpinNmb tmNmb, actNmb;
  private HGSpinNmb scNmb;
  private boolean dragf;
  private HGToggleBox slcBox;
  private HGSpinNmb slcdNmb;

  private int mode;

  public InputEvt(IHenyaG henyaG, ISurface surf,
   HnyObj[] hnyObj, HGEvent[] hgEvt, HGCanvas cvs) {
    this.henyaG = henyaG;

    setRect(0, 0, 160, 160);
    Font fnt = new Font("Helvetica", Font.BOLD, 10);
    eeTgl = new HGButton("Evt", fnt, 0, 0, 25, 15);
    ctg = new HGToggleBox(null, fnt, surf, 9, 1, HGToggleBox.CHECK, 45, 0, 11, 14);
    allBtn = new HGButton("A", fnt, 145, 0, 15, 15);
    this.cvs = cvs;
    actTgr = new HGButton("C", fnt, 28, 0, 15, 15);

    delBtn = new HGButton("Del", fnt, 105, 145, 25, 15);
    evtNmb = new HGSpinNmb(1, 99, 130, 145);
    evtNmb.nmb.tglf = true;
    for ( int i=8 ; i>=0 ; i-- ) {
      ctg.changeCheck(true, i);
    }
    String[] onfStr = {"On", "Of", "Cl"};
    onfBox = new HGToggleBox(
     onfStr, fnt, surf, 3, 1, HGToggleBox.TOGGLE, 0, 145, 16, 14);
    onfBox.setTglIdx(0);
    String[] evtStr = {"Ti", "Rn", "Ky"};
    evtBox = new HGToggleBox(
     evtStr, fnt, surf, 3, 1, HGToggleBox.CHECKEDBUTTON, 52, 145, 16, 14);

    prm1Nmb = new HGSpinNmb(0, 99, 0, 145);
    prm1Nmb.nmb.tglf = true;
    prm2Nmb = new HGSpinNmb(0, 99, 40, 145);
    prm2Nmb.nmb.tglf = true;
    String[] rnkStr = {"-", "", "0", "", "+"};
    rnkBox = new HGToggleBox(
     rnkStr, fnt, surf, 5, 1, HGToggleBox.CHECKEDBUTTON, 85, 145, 14, 14);
    doneBtn = new HGButton("Done", fnt, 120, 145, 40, 15);
    String[] keyStr = {"L2", "L1", "Up", "Dw", "R1", "R2"};
    keyBox = new HGToggleBox(
     keyStr, fnt, surf, 6, 1, HGToggleBox.TOGGLE, 0, 145, 18, 14);
    clrBtn = new HGButton("Clr", fnt, 140, 145, 20, 15);

    String[] actStr = {"n", "f", "v", "m", "s"};
    actBox = new HGToggleBox(
     actStr, fnt, surf, 5, 1, HGToggleBox.CHECKEDBUTTON, 30, 145, 14, 14);
    tmNmb = new HGSpinNmb(0, 99, 0, 145);
    tmNmb.nmb.tglf = true;
    actNmb = new HGSpinNmb(1, 99, 130, 145);
    actNmb.nmb.tglf = true;
    scNmb = new HGSpinNmb(1, 99, 0, 145);
    scNmb.nmb.tglf = true;

    String[] slcStr = {"0"};
    slcBox = new HGToggleBox(
     slcStr, fnt, surf, 10, 10, HGToggleBox.CHECKEDBUTTON, 4, 20, 15, 12);
    slcdNmb = null;

    this.hnyObj = hnyObj;
    this.hgEvt = hgEvt;
    inPress = false;
    dragf = false;
    setEdEvt(0);
    setMode(0);
    remove(cvs);
  }

  public void setEdEvt(int idx) {
    prvEvtIdx = idx;
    edEvt = null;
    if ( hgEvt[idx] == null ) {
      edEvt = new HGEvent();
    } else {
      edEvt = new HGEvent(hgEvt[idx]);
    }
    actNmb.setNumber((int)(edEvt.actCnt/3)+1);
  }

  public void setEvt(int idx) {
    hgEvt[idx] = edEvt;
    hgEvt[idx].cmprsData();
  }

  public void start() {
    //if ( grp == null ) {
    //  grp = createGraphics();
    //}
    //grp.setDrawOp(Graphics.DRAW_OVER);
    cvs.setEnabled(false);
    cvs.setCanvasParent(this);
    setEdEvt(evtNmb.number-1);
    setMode(mode);
  }

  private void repaintEdEvt() {
    if ( edEvt.containsSpc(10) != -1 ) evtBox.changeCheck(true, 0);
    else evtBox.changeCheck(false, 0);
    if ( edEvt.containsSpc(20) != -1 ) evtBox.changeCheck(true, 1);
    else evtBox.changeCheck(false, 1);
    if ( edEvt.containsSpc(0) != -1 ) evtBox.changeCheck(true, 2);
    else evtBox.changeCheck(false, 2);
    evtBox.repaint();
  }

  private void setMode(int mode) {
    removeControl();
    add(eeTgl);
    add(allBtn);
    add(ctg);
    add(actTgr);
    add(cvs);

    this.mode = mode;
    switch ( mode ) {
      case 0:
        add(delBtn);
        add(evtNmb);
        add(onfBox);
        add(evtBox);
        repaintEdEvt();
        break;
      case 1:
      case 2:
        add(prm1Nmb);
        add(prm2Nmb);
        add(rnkBox);
        int idx = edEvt.containsSpc(mode*10);
        rnkBox.clearCheck();
        if ( idx != -1 ) {
          prm1Nmb.setNumber(edEvt.cnd[idx+1]);
          prm2Nmb.setNumber(edEvt.cnd[idx+2]);
          int rn = edEvt.cnd[idx]%10;
          rnkBox.setTglIdx(rn);
          rnkBox.changeCheck(true, rn);
        } else {
          prm1Nmb.setNumber(0);
          prm2Nmb.setNumber(0);
        }
        break;
      case 3:
        add(keyBox);
        add(clrBtn);
        int sIdx = edEvt.containsSpc(0);
        if ( sIdx != -1 ) {
          keyBox.setTglIdx(edEvt.cnd[sIdx+1]);
        } else {
          keyBox.clearCheck();
        }
        break;
      case 4:
        add(tmNmb);
        add(actBox);
        add(delBtn);
        add(actNmb);
        actNmb.max = (int)(edEvt.actCnt/3)+1;
        actNmb.setNumberRgn(actNmb.number);
        int aidx = (actNmb.number-1)*3;
        int an = edEvt.act[aidx];
        if ( an == 0 && actBox.tglIdx < 3 ) break;
        actBox.clearCheck();
        if ( an > 0 ) {
          actBox.setTglIdx(an-1);
          actBox.changeCheck(true, an-1);
          tmNmb.setNumber(edEvt.act[aidx+2]);
        } else {
          actBox.tglIdx = -1;
        }
        break;
      case 5:
        add(scNmb);
        add(doneBtn);
        break;
    }
    if ( slcdNmb != null ) {
      slcdNmb.nmb.setCheck(false);
      slcdNmb.repaint();
      slcdNmb = null;
      //clearCntUI();
      updateHnyObjall();
    }
  }

  private void drawOnOff(int spc, int idx) {
    HnyObj hobj = hnyObj[idx];
    cvs.drawOnOff(hobj, spc);
  }

  private void drawOnOff2(int spc, int idx) {
    HnyObj hobj = hnyObj[idx];
    cvs.drawOnOff2(hobj, spc);
  }

  public void updateHnyObjall() {
    cvs.clear();
    //grp.setColor(0, 0, 0);
    //grp.setDrawOp(Graphics.DRAW_OR);
    for ( int i=98 ; i>=0 ; i-- ) {
      HnyObj hobj = hnyObj[i];
      if ( hobj != null && ctg.check[hobj.ctg] ) {
        //grp.drawImage(hobj.img, hobj.x, hobj.y);
        hobj.draw();
        //grp.copyRect(cvs.oimg, hobj.x, hobj.y, hobj.width, hobj.height, hobj.x, hobj.y);
        if ( mode < 4 ) {
          int spc = edEvt.containsHObj(i);
          drawOnOff(spc, i);
        }
      }
    }
    if ( mode > 3 ) {
      int idx =(actNmb.number-1)*3;
      int spc = edEvt.act[idx];
      if ( spc > 0 && spc < 4 ) drawOnOff(spc, edEvt.act[idx+1]);
      if ( idx >= 3 ) {
        spc = edEvt.act[idx-3];
        if ( spc > 0 && spc < 4 ) drawOnOff2(spc, edEvt.act[idx-2]);
      }
    }
    //grp.setDrawOp(Graphics.DRAW_OVER);
  }

  public void updateHnyObj() {
    for ( int i=98 ; i>=0 ; i-- ) {
      HnyObj hobj = hnyObj[i];
      if ( hobj != null && ctg.check[hobj.ctg] ) {
        if ( mode < 4 ) {
          int spc = edEvt.containsHObj(i);
          drawOnOff(spc, i);
        } else {
          cvs.clearOnOff(hobj);
        }
      }
    }
    if ( mode > 3 ) {
      int idx =(actNmb.number-1)*3;
      int spc = edEvt.act[idx];
      if ( spc > 0 && spc < 4 ) drawOnOff(spc, edEvt.act[idx+1]);
      if ( idx >= 3 ) {
        spc = edEvt.act[idx-3];
        if ( spc > 0 && spc < 4 ) drawOnOff2(spc, edEvt.act[idx-2]);
      }
    }
  }

  private int abs(int n) {
    if ( n < 0 ) return -n;
    else return n;
  }

  private int getNearestHnyObj(int x, int y) {
    int dst = 10000, idx = -1;
    for ( int i=98 ; i>=0 ; i-- ) {
      if ( hnyObj[i] != null ) {
        HnyObj hobj = hnyObj[i];
        if ( ctg.check[hobj.ctg] &&
             x >= hobj.x && x <= hobj.x+hobj.width &&
             y >= hobj.y && y <= hobj.y+hobj.height ) {
          int d = abs(hobj.x-x) + abs(hobj.y-y);
          if ( dst > d ) {
            dst = d; idx = i;
          }
        }
      }
    }
    return idx;
  }

  public void onEvent(Event e) {
    if ( slcdNmb != null
     && e.target == slcdNmb.nmb && e.type == ControlEvent.PRESSED ) {
      slcdNmb = null;
      remove(slcBox);
      add(cvs);
      //clearCntUI();
      updateHnyObjall();
    } else if ( e.target == ctg && e.type == ControlEvent.PRESSED ) {
      updateHnyObjall();
    } else if ( e.target == cvs ) {
      if ( e instanceof PenEvent ) {
        PenEvent pe =  (PenEvent)e;
        int x = pe.x, y = pe.y;
        if ( mode == 0 ) {
          if ( e.type==PenEvent.PEN_DOWN || e.type==PenEvent.PEN_DRAG ) {
          int idx = getNearestHnyObj(x, y);
          if ( idx != -1 ) {
            switch ( onfBox.tglIdx ) {
              case 0:
                if ( edEvt.addCnd(1, idx, 0) ) {
                  edEvt.delCnd(2, idx);
                  drawOnOff(1, idx);
                }
                break;
              case 1:
                if ( edEvt.addCnd(2, idx, 0) ) {
                  edEvt.delCnd(1, idx);
                  drawOnOff(2, idx);
                }
                break;
              case 2:
                if ( edEvt.delCnd(1, idx) || edEvt.delCnd(2, idx) ) {
                  drawOnOff(-1, idx);
                }
                break;
            }
          }
          }
        } else if ( mode == 4 ) {
          if ( e.type == PenEvent.PEN_DOWN || e.type == PenEvent.PEN_DRAG ) {
          int idx = getNearestHnyObj(x, y);
          if ( idx != -1 ) {
            switch ( actBox.tglIdx ) {
              case 0:
              case 1:
              case 2:
                int an = actNmb.number;
                if ( edEvt.addAct(an-1, actBox.tglIdx+1, idx, tmNmb.number, dragf) ) {
                  drawOnOff(actBox.tglIdx+1, idx);
                  an++; if ( an > 99 ) an = 1;
                  //actNmb.setNumberWOEvent(an);
                  actNmb.setNumber(an);
                }
                break;
            }
            dragf = true;
          }
          } else {
            dragf = false;
          }
        }
      }
    } else if ( e.target == slcBox && e instanceof HGTglBoxEvent ) {
      HGTglBoxEvent te = (HGTglBoxEvent)e;
      if ( te.type == HGTglBoxEvent.PRESSED ) {
        int sb = te.idx;
        slcdNmb.setNumberRgn(sb);
        slcdNmb.nmb.setCheck(false);
        slcdNmb = null;
        remove(slcBox);
        add(cvs);
        updateHnyObjall();
      }
    }

    switch ( mode ) {
    case 0:
    if ( e.target == evtBox && e instanceof HGTglBoxEvent ) {
      HGTglBoxEvent te = (HGTglBoxEvent)e;
      if ( te.type == HGTglBoxEvent.PRESSED ) {
        int eb = te.idx;
        setMode(eb+1);
      }
    } else if ( e.target == delBtn && e.type == ControlEvent.PRESSED ) {
      hgEvt[evtNmb.number-1] = null;
      edEvt = null;
      edEvt = new HGEvent();
      updateHnyObj();
      repaintEdEvt();
    } else if ( e.target == evtNmb.nmb && e.type == HGButtonEvent.CHECKED ) {
        if ( slcdNmb == null ) {
          slcdNmb = evtNmb;
          boolean f;
          HGEvent ce;
          for ( int i=98 ; i>=0 ; i-- ) {
            if ( i+1 == evtNmb.number ) ce = edEvt;
            else ce = hgEvt[i];
            if ( ce == null || ce.actCnt==0 && ce.cndCnt==0 ) f = false;
            else f = true;
            slcBox.changeCheck(f, i+1);
          }
          remove(cvs);
          add(slcBox);
        }
    } else if ( e.target == evtNmb && e.type == HGSpinNmbEvent.CHANGED ) {
      setEvt(prvEvtIdx);
      setEdEvt(evtNmb.number-1);
      updateHnyObj();
      repaintEdEvt();
    }
    break;

    case 1:
    case 2:
    if ( e.target == prm1Nmb.nmb && e.type == HGButtonEvent.CHECKED ) {
      if ( slcdNmb == null ) {
        slcdNmb = prm1Nmb;
        startSlcUI();
      }
    } else if ( e.target == prm2Nmb.nmb && e.type == HGButtonEvent.CHECKED ) {
      if ( slcdNmb == null ) {
        slcdNmb = prm2Nmb;
        startSlcUI();
      }
    } else if ( e.target == rnkBox && e instanceof HGTglBoxEvent ) {
      HGTglBoxEvent te = (HGTglBoxEvent)e;
      if ( te.type == HGTglBoxEvent.PRESSED ) {
        int rb = te.idx;
        edEvt.delCnd(mode*10);
        if ( prm2Nmb.number != 0 ) {
          edEvt.addCnd(mode*10+rb, prm1Nmb.number, prm2Nmb.number);
        }
        setMode(0);
      }
    }
    break;

    case 3:
    if ( e.target == clrBtn && e.type == ControlEvent.PRESSED ) {
      keyBox.clearCheck();
      edEvt.delCnd(0);
      if ( keyBox.tglIdx >= 0 ) {
        edEvt.addCnd(0, keyBox.tglIdx);
      }
      setMode(0);
    } else if ( e.target == keyBox && e instanceof HGTglBoxEvent ) {
      HGTglBoxEvent te = (HGTglBoxEvent)e;
      if ( te.type == HGTglBoxEvent.IDXCHANGED ) {
        edEvt.delCnd(0);
        if ( keyBox.tglIdx >= 0 ) {
          edEvt.addCnd(0, keyBox.tglIdx);
        }
        setMode(0);
      }
    }
    break;

    case 4:
    if ( e.target == actBox && e instanceof HGTglBoxEvent ) {
      HGTglBoxEvent te = (HGTglBoxEvent)e;
      if ( te.type == ControlEvent.PRESSED ) {
        int ab = te.idx;
        actBox.clearCheck();
        actBox.setTglIdx(ab);
        actBox.changeCheck(true, ab);
        actBox.repaint();
        switch (ab) {
          case 3:
            int an = actNmb.number;
            edEvt.addAct(an-1, 4, tmNmb.number);
            an++; if ( an > 99 ) an = 1;
            actNmb.setNumber(an);
            break;
          case 4:
            setMode(5);
            break;
        }
      }
    } else if ( e.target == delBtn && e.type == ControlEvent.PRESSED ) {
      edEvt.delAct(actNmb.number-1);
      setMode(4);
      updateHnyObj();
    } else if ( e.target == actNmb.nmb && e.type == HGButtonEvent.CHECKED ) {
      if ( slcdNmb == null ) {
        slcdNmb = actNmb;
        int idx = (int)(edEvt.actCnt/3);
        boolean f;
        for ( int i=98 ; i>=0 ; i-- ) {
          if ( i<idx ) f = true;
          else f = false;
          slcBox.changeCheck(f, i+1);
        }
        remove(cvs);
        add(slcBox);
      }
    } else if ( e.target == tmNmb.nmb && e.type == HGButtonEvent.CHECKED ) {
      if ( slcdNmb == null ) {
        slcdNmb = tmNmb;
        startSlcUI();
      }
    } else if ( e.target == actNmb && e.type == HGSpinNmbEvent.CHANGED ) {
      actNmb.max = (int)(edEvt.actCnt/3)+1;
      actNmb.setNumberRgnWOEvent(actNmb.number);
      int aidx = (actNmb.number-1)*3;
      int an = edEvt.act[aidx];
      updateHnyObj();
      if ( an == 0 && actBox.tglIdx < 3 ) break;
      actBox.clearCheck();
      if ( an > 0 ) {
        actBox.setTglIdx(an-1);
        actBox.changeCheck(true, an-1);
        tmNmb.setNumber(edEvt.act[aidx+2]);
      } else {
        actBox.tglIdx = -1;
      }
    }
    break;

    case 5:
    if ( e.target == scNmb.nmb && e.type == HGButtonEvent.CHECKED ) {
      if ( slcdNmb == null ) {
        slcdNmb = scNmb;
        startSlcUI();
      }
    } else if ( e.target == doneBtn && e.type == ControlEvent.PRESSED ) {
        int an = actNmb.number;
        edEvt.addAct(an-1, 5, scNmb.number, tmNmb.number);
        an++; if ( an > 99 ) an = 1;
        actNmb.setNumber(an);
        setMode(4);
    }
    }

    if ( e.target == allBtn && e.type == ControlEvent.PRESSED ) {
      boolean f = true;
      for ( int i=8 ; i>=0 ; i-- ) {
        if ( !ctg.check[i] ) f = false;
      }
      f = !f;
      for ( int i=8 ; i>=0 ; i-- ) {
        ctg.changeCheck(f, i);
      }
      ctg.repaint();
      updateHnyObjall();
    } else if ( e.target == actTgr && e.type == ControlEvent.PRESSED ) {
      if ( mode == 0 ) {
        actTgr.setText("A");
        setMode(4);
      } else {
        actTgr.setText("C");
        setMode(0);
      }
    } else if ( e.target == eeTgl && e.type == ControlEvent.PRESSED ) {
      setEvt(evtNmb.number-1);
      remove(cvs);
      henyaG.changeMode(0);
    }
  }

  private void startSlcUI() {
    for ( int i=98 ; i>=0 ; i-- ) slcBox.changeCheck(false, i);
    remove(cvs);
    add(slcBox);
    slcBox.repaint();
  }

  public void canvasPainted(Graphics g) {
    if ( slcdNmb == null ) {
      updateHnyObjall();
    }
  }
}
