import waba.ui.*;
import waba.fx.*;

/**
  Input object data UI
  */
public class InputObj extends Container implements ICanvasParent {
  //private Graphics grp;
  private IHenyaG henyaG;
  private HGButton oeTgl, allBtn, delBtn;
  private HGToggleBox ctg, setCtg;
  private HGCanvas cvs;
  public HGSpinNmb objNmb;
  private HnyObj[] hnyObj;
  private HGEvent[] hgEvt;

  private int blinkCnt, blinkIdx;
  //private Image blinkImg;

  public InputObj(IHenyaG henyaG, ISurface surf,
   HnyObj[] hnyObj, HGEvent[] hgEvt, HGCanvas cvs) {
    this.henyaG = henyaG;
    this.hgEvt = hgEvt;

    setRect(0, 0, 160, 160);
    Font fnt = new Font("Helvetica", Font.BOLD, 10);
    oeTgl = new HGButton("Obj", fnt, 0, 0, 25, 15);
    ctg = new HGToggleBox(null, fnt, surf, 9, 1, HGToggleBox.CHECK, 45, 0, 11, 14);
    allBtn = new HGButton("A", fnt, 145, 0, 15, 15);
    this.cvs = cvs;
    setCtg = new HGToggleBox(null, fnt, surf, 9, 1, HGToggleBox.BUTTON, 0, 145, 11, 14);
    delBtn = new HGButton("Del", fnt, 105, 145, 25, 15);
    objNmb = new HGSpinNmb(1, 99, 130, 145);
    objNmb.nmb.tglf = true;
    for ( int i=8 ; i>=0 ; i-- ) ctg.changeCheck(true, i);

    this.hnyObj = hnyObj;

    blinkCnt = -1;
    /*Size sz = surf.getSize();
    blinkImg = new Image(sz.getWidth(), sz.getHeight());
    Graphics g = new Graphics(blinkImg);
    g.setColor(0, 0, 0);
    g.fillRect(0, 0, 160, 160);*/

    add(oeTgl);
    add(allBtn);
    add(delBtn);
    add(ctg);
    add(setCtg);
    add(objNmb);
  }

  public void start() {
    //if ( grp == null ) {
    //  grp = createGraphics();
    //}
    //grp.setDrawOp(Graphics.DRAW_OVER);
    add(cvs);
    cvs.setEnabled(true);
    cvs.setImage();
    cvs.setCanvasParent(this);
  }

  public void updateHnyObj() {
    cvs.clear();
    //grp.setColor(0, 0, 0);
    //grp.setDrawOp(Graphics.DRAW_OR);
    for ( int i=98 ; i>=0 ; i-- ) {
      HnyObj hobj = hnyObj[i];
      if ( hobj != null && ctg.check[hobj.ctg] ) {
        //grp.drawImage(hobj.img, hobj.x, hobj.y);
        hobj.draw();
        //grp.copyRect(cvs.oimg, hobj.x, hobj.y, hobj.width, hobj.height, hobj.x, hobj.y);
      }
    }
    cvs.drawCurrentHnyObj();
    //grp.setDrawOp(Graphics.DRAW_OVER);
  }

  private int abs(int n) {
    if ( n < 0 ) return -n;
    else return n;
  }

  private int getNearestHnyObj(int x, int y) {
    int dst = 10000, idx = -1;
    for ( int i=98 ; i>=0 ; i-- ) {
      if ( hnyObj[i] != null ) {
        HnyObj hobj = hnyObj[i];
        if ( ctg.check[hobj.ctg] &&
             x >= hobj.x && x <= hobj.x+hobj.width &&
             y >= hobj.y && y <= hobj.y+hobj.height ) {
          int d = abs(hobj.x-x) + abs(hobj.y-y);
          if ( dst > d ) {
            dst = d; idx = i;
          }
        }
      }
    }
    return idx;
  }

  public void onEvent(Event e) {
    if ( e.target == objNmb.nmb ) {
      if ( e.type == HGButtonEvent.CHECKED ) {
        cvs.setEnabled(false);
        cvs.setImage();
        updateHnyObj();
      } else if ( e.type == HGButtonEvent.UNCHECKED ) {
        cvs.setEnabled(true);
      }
    } else if ( e.target == cvs ) {
      if ( e.type == PenEvent.PEN_DOWN ) {
        if ( objNmb.nmb.inPress ) {
          PenEvent pe = (PenEvent)e;
          int idx = getNearestHnyObj(pe.x, pe.y);
          if ( idx != -1 ) {
            objNmb.setNumber(idx+1);
          } else {
            for ( int i=98 ; i>=0 ; i-- ) {
              idx++; if ( idx > 98 ) idx = 0;
              if ( hnyObj[idx] == null ) {
                objNmb.setNumber(idx+1);
                break;
              }
            }
          }
        }
      }
    } else if ( e.target == ctg ) {
      if ( e.type == HGTglBoxEvent.IDXCHANGED ) {
        updateHnyObj();
      }
    } else if ( e.target == setCtg ) {
      if ( e.type == HGTglBoxEvent.PRESSED ) {
        HGTglBoxEvent te = (HGTglBoxEvent)e;
        int sc = te.idx;
        HnyObj hobj = cvs.getHObj();
        if ( hobj == null ) return;
        int idx = objNmb.number - 1;
        hobj.nmb = idx; hobj.ctg = sc;
        boolean udf = false;
        if ( hnyObj[idx] != null ) {
          udf = true;
          HnyObj ho = hnyObj[idx];
          cvs.oig.setColor(255, 255, 255);
          cvs.oig.fillRect(ho.x, ho.y, ho.width, ho.height);
          cvs.oig.setColor(0, 0, 0);
        }
        hobj.draw(cvs.oig);
        hnyObj[idx] = hobj;

        //hnyObj[idx].writePD(idx);

        if ( udf ) updateHnyObj();

        blinkIdx = idx; blinkCnt = 6;
        cvs.setImage();

        for ( int i=98 ; i>=0 ; i-- ) {
          idx++; if ( idx > 98 ) idx = 0;
          if ( hnyObj[idx] == null ) {
            objNmb.setNumber(idx+1);
            break;
          }
        }
        if ( !ctg.check[sc] ) {
          ctg.changeCheck(true, sc);
        }
      }
    } else if ( e.target==allBtn && e.type==ControlEvent.PRESSED ) {
      boolean f = true;
      for ( int i=8 ; i>=0 ; i-- ) {
        if ( !ctg.check[i] ) f = false;
      }
      f = !f;
      for ( int i=8 ; i>=0 ; i-- ) {
        ctg.changeCheck(f, i);
      }
      updateHnyObj();
    } else if ( e.target == delBtn && e.type==ControlEvent.PRESSED ) {
      int on = objNmb.number-1;
      HnyObj ho = hnyObj[on];
      if ( ho != null ) {
        cvs.oig.setColor(255, 255, 255);
        cvs.oig.fillRect(ho.x, ho.y, ho.width, ho.height);
        cvs.oig.setColor(0, 0, 0);
        hnyObj[on] = null;
      }
      for ( int i=hgEvt.length-1 ; i>=0 ; i-- ) {
        if ( hgEvt[i] != null ) {
          hgEvt[i].delCnds(on);
          hgEvt[i].delActs(on);
          hgEvt[i].cmprsData();
        }
      }
      cvs.setImage();
      updateHnyObj();
    } else if ( e.target == objNmb && e.type==HGSpinNmbEvent.CHANGED ) {
      if ( hnyObj[objNmb.number-1] != null ) {
        blinkIdx = objNmb.number-1; blinkCnt = 2;
        cvs.setImage();
      }
    } else if ( e.target == oeTgl && e.type==ControlEvent.PRESSED ) {
      remove(cvs);
      henyaG.changeMode(0);
    }
  }

  public void canvasPainted(Graphics g) {
    updateHnyObj();
  }

  public void onTimerTick() {
    if ( blinkCnt > 0 ) {
      HnyObj hobj = hnyObj[blinkIdx];
      cvs.blinkHnyObj(hobj, blinkCnt);
      blinkCnt--;
    }
  }
}
