import waba.ui.*;
import waba.fx.*;

/**
  Input game propertie UI
  */
public class InputPrp extends Container {
  private Graphics grp;
  private HenyaG henyaG;
  private GamePrp gamePrp;
  private HGToggleBox ctgBox;
  private HGSpinNmb leftNmb;
  private HGButton doneBtn;
  private boolean inPress;

  public InputPrp(HenyaG henyaG, ISurface surf, GamePrp gamePrp) {
    this.henyaG = henyaG;
    this.gamePrp = gamePrp;

    setRect(0, 0, 160, 160);
    Font fnt = new Font("Helvetica", Font.BOLD, 10);
    ctgBox = new HGToggleBox(
     null, fnt, surf, 9, 1, HGToggleBox.CHECK, 0, 145, 11, 14);
    doneBtn = new HGButton("Done", fnt, 120, 145, 40, 15);
    leftNmb = new HGSpinNmb(1, 99, 130, 0);
    add(ctgBox);
    add(leftNmb);
    add(doneBtn);
  }

  public void start() {
    for ( int i=8 ; i>=0 ; i-- ) {
      ctgBox.changeCheck(gamePrp.dspCtg[i], i);
    }
    ctgBox.repaint();
    leftNmb.setNumber(gamePrp.left);
    if ( grp == null ) {
      grp = createGraphics();
    }
    grp.setDrawOp(Graphics.DRAW_OVER);
    grp.setColor(0, 0, 0);
  }

  public void onEvent(Event e) {
    if ( e.type == PenEvent.PEN_DRAG ) {
      PenEvent pe = (PenEvent)e;
      int x = pe.x, y = pe.y;
      if ( x>=5 && x<=154 ) {
        int idx = (int)((x-5)/3), by;
        if ( y>=19 && y<=78 ) {
          by = gamePrp.gameSpeed[idx]+19;
          grp.setColor(255, 255, 255);
          grp.drawLine(5+idx*3, by, 7+idx*3, by);
          gamePrp.gameSpeed[idx] = (byte)(y-19);
          by = gamePrp.gameSpeed[idx]+19;
          grp.setColor(0, 0, 0);
          grp.drawLine(5+idx*3, by, 7+idx*3, by);
        }
        if ( y>=80 && y<=139 ) {
          by = gamePrp.rank[idx]+80;
          grp.setColor(255, 255, 255);
          grp.drawLine(5+idx*3, by, 7+idx*3, by);
          gamePrp.rank[idx] = (byte)(y-80);
          by = gamePrp.rank[idx]+80;
          grp.setColor(0, 0, 0);
          grp.drawLine(5+idx*3, by, 7+idx*3, by);
        }
      }
    } else if ( e.target == doneBtn && e.type == ControlEvent.PRESSED ) {
      for ( int i=8 ; i>=0 ; i-- ) {
        gamePrp.dspCtg[i] = ctgBox.check[i];
      }
      gamePrp.left = (byte)leftNmb.number;
      henyaG.changeMode(0);
    }
  }

  private void drawGrp(Graphics grp) {
    int y;
    for ( int i=49 ; i>=0 ; i-- ) {
      y = gamePrp.gameSpeed[i]+19;
      grp.drawLine(5+i*3, y, 7+i*3, y);
      y = gamePrp.rank[i]+80;
      grp.drawLine(5+i*3, y, 7+i*3, y);
    }
  }

  public void onPaint(Graphics grp) {
    grp.setColor(255, 255, 255);
    grp.fillRect(0, 15, 160, 130);
    grp.setColor(0, 0, 0);
    grp.drawLine(5, 18, 154, 18);
    grp.drawLine(155, 19, 155, 139);
    grp.drawLine(154, 140, 5, 140);
    grp.drawLine(4, 139, 4, 19);
    grp.drawLine(5, 79, 154, 79);
    for ( int i=8 ; i>=0 ; i-- ) {
      grp.drawLine(20+i*15, 16, 20+i*15, 17);
      grp.drawLine(20+i*15, 141, 20+i*15, 142);
    }
    grp.drawLine(3, 49, 4, 49);
    grp.drawLine(156, 49, 157, 49);
    grp.drawLine(3, 110, 4, 110);
    grp.drawLine(156, 110, 157, 110);
    drawGrp(grp);
    super.onPaint(grp);
  }
}

