import waba.ui.*;
import waba.fx.*;

/**
  Main menu UI
  */
public class MainMenu extends RmblContainer {
  private HenyaG henyaG;
  private HGButton obj, evt, game, prp, del;
  private HGToggleBox slotBox;
  private Title title;
  private HGButton delY, delN;
  private int mode;

  public MainMenu(HenyaG henyaG, ISurface surf) {
    this.henyaG = henyaG;

    setRect(0, 0, 160, 160);
    Font fnt = new Font("Helvetica", Font.BOLD, 10);
    obj = new HGButton("Obj", fnt, 0, 145, 25, 15);
    evt = new HGButton("Evt", fnt, 25, 145, 25, 15);
    prp = new HGButton("Prp", fnt, 50, 145, 25, 15);
    game = new HGButton("Gam", fnt, 75, 145, 25, 15);
    del = new HGButton("Del", fnt, 135, 145, 25, 15);
    slotBox = new HGToggleBox(
     null, fnt, surf, 1, 10, HGToggleBox.TOGGLE, 0, 20, 15, 12);
    title = new Title("HenyaG");
    title.setRect(0, 0, 160, 15);
    delY = new HGButton("Y", fnt, 0, 145, 15, 15);
    delN = new HGButton("N", fnt, 20, 145, 15, 15);
    setMode(0);
  }

  private void setMode(int mode) {
    removeControl();

    this.mode = mode;
    add(title);
    add(slotBox);
    switch ( mode ) {
      case 0:
        add(obj);
        add(evt);
        add(prp);
        add(game);
        add(del);
        break;
      case 1:
        add(delY);
        add(delN);
        break;
    }
    repaint();
  }

  public void onEvent(Event e) {
    switch ( mode ) {
      case 0:
        if ( e.target == obj && e.type == ControlEvent.PRESSED ) {
          henyaG.changeMode(1);
        } else if ( e.target == evt && e.type == ControlEvent.PRESSED ) {
          henyaG.changeMode(2);
        } else if ( e.target == prp && e.type == ControlEvent.PRESSED ) {
          henyaG.changeMode(3);
        } else if ( e.target == game && e.type == ControlEvent.PRESSED ) {
          henyaG.changeMode(4);
        } else if ( e.target == del && e.type == ControlEvent.PRESSED ) {
          setMode(1);
        }
        break;
      case 1:
        if ( e.target == delY && e.type == ControlEvent.PRESSED ) {
          henyaG.clearDB();
          henyaG.clearAll();
          setMode(0);
        } else if ( e.target == delN && e.type == ControlEvent.PRESSED ) {
          setMode(0);
        }
        break;
    }
    if ( e.target == slotBox && e.type == HGTglBoxEvent.IDXCHANGED ) {
      henyaG.drawMessage("Now Saving..");
      henyaG.saveSlot();
      henyaG.drawMessage("Now Loading..");
      henyaG.loadSlot(slotBox.tglIdx+1);
      Graphics grp = createGraphics();
      grp.clearClip();
      repaint();
    }
  }
}

